!
!  PlaneDomains Copyright (C) 2013  Marco Spadini
! 
!  This file is part of PlaneDomains.
!  PlaneDomains are free software: you can redistribute it and/or modify 
!  it under the terms of the GNU General Public License as published by the 
!  Free Software Foundation, either version 3 of the License, or (at your 
!  option) any later version.
! 
!  PlaneDomains are distributed in the hope that it will be useful, but 
!  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
!  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
!  more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with StartingPoints-1D.  If not, see <http://www.gnu.org/licenses/>.
!  
!  
!  About the author:
!  Marco Spadini                         
!  Dipartimento di Matematica e Informatica,
!  Via S. Marta 3, 50139 Firenze,       
!  ITALY 
!  
!  web: http:\\www.dma.unifi.it\~spadini
!  e-mail: marco.spadini@unifi.it
! 
! 

program montecarlo
  implicit none
  interface
    function f(x)
    real, dimension(2) :: x
    logical :: f
    end function f
  end interface

character (len=8) :: a1,b1,c1,d1,n1
  real :: a, b, c, d
  logical :: v , v1 , v2
  real, dimension(2) :: sw , xysize 
  real, dimension(2) :: x0 , x1 , x2
  integer :: m = 0, i, n 
  real,allocatable,dimension(:,:) :: puntiAcaso
  
call getarg(1,a1)
call getarg(2,b1)
call getarg(3,c1)
call getarg(4,d1)
call getarg(5,n1)
  read(a1,*) a 
  read(b1,*) b  
  read(c1,*) c 
  read(d1,*) d  
  read(n1,*) n
  allocate(puntiAcaso(2,0:n))
  call random_number(puntiAcaso)

  sw = (/ a , b /)
  xysize= (/ c-a , d-b /)
  forall (i=0:n)
     puntiAcaso(:,i)=sw+xysize*puntiAcaso(:,i)
     end forall
  
  open(unit=1,file='disegno.dat',form='formatted',status='unknown',asynchronous='yes')

  do i=0,n
      x0=puntiAcaso(i,:);
      v=f(x0);
      if (v) then
        write(1,*) x0(1), x0(2)
        end if;
      x1=puntiAcaso(i+1,:);
      v1=f(x1);
      if (v1) then
        write(1,*) x1(1), x1(2)
        end if;
      if (v1 .NEQV. v) then
        x2=(x0+x1)/2.
        do m=1,10
          v2=f(x2)
          if (v .NEQV. v2) then
            x1=x2
          else
            x0=x2
            v=v2
          end if;
        x2=(x0+x1)/2.
        end do
        write(1,*) x2(1), x2(2)
      endif
    end do
  deallocate(puntiAcaso)
end program montecarlo
